<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "gmb_category_mapping".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "GmbCategoryMapping".
 *
 * Columns in table "gmb_category_mapping" available as properties of the model.
 *
 * @property integer $id
 * @property integer $gmb_category_id
 * @property string $sub_specialty_id
 * @property string $date_added
 * @property string $date_updated
 */
abstract class BaseGmbCategoryMapping extends BaseModel
{

    public $gmb_category;
    public $sub_specialty;
    public $level;
    public $specialty;
    public $specialty_id;
    public $gcid;

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'gmb_category_mapping';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'Gmb Category Mapping', $n);
    }

    public function rules()
    {
        return array(
            array('sub_specialty_id', 'required'),
            array('sub_specialty', 'safe', 'on' => 'search'),
            array('sub_specialty_id', 'safe', 'on' => 'search'),
            array('specialty', 'safe', 'on' => 'search'),
            array('specialty_id', 'safe', 'on' => 'search'),
            array('level', 'safe', 'on' => 'search'),
            array('gmb_category', 'safe', 'on' => 'search'),
            array('gcid', 'safe', 'on' => 'search'),
            array('gmb_category_id', 'safe', 'on' => 'search'),
            array('date_added', 'safe', 'on' => 'search'),
            array('date_updated', 'safe', 'on' => 'search'),
        );
    }

//    public function relations() {
//        return array(
//            'gmb_category' => array(self::BELONGS_TO, 'GmbCategory', 'gmb_category_id'),
//            'sub_specialty' => array(self::BELONGS_TO, 'SubSpecialty', 'sub_specialty_id'),
//        );
//    }

    public function attributeLabels()
    {
        return array(
            'gmb_category_id' => Yii::t('app', 'GMB Category'),
            'sub_specialty_id' => Yii::t('app', 'Sub Specialty'),
            'specialty_id' => Yii::t('app', 'Specialty')
        );
    }

    /**
     * Filters the GMB Category Mapping
     * @return \CActiveDataProvider
     */
    public function search()
    {
        $criteria = new CDbCriteria;
        $criteria->compare('t.id', $this->id);
        $criteria->compare('t.gmb_category_id', $this->gmb_category_id);
        $criteria->compare('t.sub_specialty_id', $this->sub_specialty_id);
        $criteria->compare('gmb_category.name', $this->gmb_category, true);
        $criteria->compare('sub_specialty.name', $this->sub_specialty, true);
        $criteria->compare('specialty.name', $this->specialty, true);
        $criteria->compare('specialty.id', $this->specialty_id);
        $criteria->compare('specialty.level', $this->level, true);
        $criteria->compare('gmb_category.gcid', $this->gcid);
        $criteria->compare('DATE_FORMAT(date_added, \'%Y-%m-%d\')', $this->date_added);
        $criteria->compare('DATE_FORMAT(date_updated, \'%Y-%m-%d\')', $this->date_updated);

        $criteria->select = 't.*,gmb_category.name as gmb_category,gmb_category.gcid,sub_specialty.name as sub_specialty,specialty.id as specialty_id,specialty.name as specialty,specialty.level';

        $criteria->join = ' LEFT JOIN gmb_category ON gmb_category.id=t.gmb_category_id'
                . ' LEFT JOIN sub_specialty ON sub_specialty.id=t.sub_specialty_id'
                . ' LEFT JOIN specialty ON specialty.id=sub_specialty.specialty_id';

        $oCActiveDataProvider = new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array(
                'pageSize' => 100,
            )
        ));
        return $oCActiveDataProvider;
    }

}
